/*
  LMX2330/2331/2332 "Three wire" controller with Arduino
  PLL 27MHz, GPS REFERENCE 10MHz or 5 MHz 
  Source:http://www.g8ajn.tv/dlother3.html
  Modified by YO4HFU / 2017
  ******************************************************
  ARDUINO ATTINY85 pins: 
  Switch = port 3, PIN 2
  PLL LE = port 2, PIN 7 
  PLL DATA = port 1, PIN 6  
  PLL CLK = port 0, PIN 5
  
  Switch connected between pin 2 and GND. Is used to change R divider ratio, 5MHz REF possible to use.
  *******************************************************
  CLOCK WIDTH = 0,01 msec (8MHz)
 */
 
 //Registers calculated by Code Loader 4 software; Take care during Binary-Hexa conversion. MSB first.
 
  const unsigned long IF_R_1 = 0x160028; //PLL IF 27MHz; REF=10MHz; CP=1MHz; X4; Normal; RF PLL PW_DN; FoLD IF PLL Locked
  const unsigned long IF_N_1 = 0x60D;  
  const unsigned long RF_R_1 = 0x6002A;
  const unsigned long RF_N_1 = 0x30006F;
  
  const unsigned long IF_R_2 = 0x160014; //PLL IF 27MHz; REF=5MHz; CP=1MHz; X4; Normal; RF PLL PW_DN; FoLD IF PLL Locked
  const unsigned long IF_N_2 = 0x60D; 
  const unsigned long RF_R_2 = 0x6002A;
  const unsigned long RF_N_2 = 0x30006F;
  
  int bp;
  int SWstate = 0; //variable for reading the Switch
  unsigned long DTA;
  
  const int LE =  2; // Arduino pins
  const int DATA =  1;
  const int CLK =  0;
  const int SWpin = 3;
  


void setup() {       
  pinMode (LE, OUTPUT);  // latch 
  pinMode (CLK, OUTPUT);  // clock
  pinMode (DATA, OUTPUT);  // data
  pinMode (SWpin, INPUT); //switch input
  digitalWrite(SWpin, HIGH); // turn on pullup resistor
  
  digitalWrite(LE,LOW); // clear LE line
  digitalWrite(CLK,LOW); // clear CLK line


//while(true) { // While enable: Start loop and send SPI signals forever. Better to not use due output jitter.
                 // While disable: Power ON, read Switch and send SPI only one time. Need power restart in case of switch changed.
    
 SWstate = digitalRead(SWpin); //Read Switch input
 if (SWstate == HIGH) { 
 
 
 DTA = IF_R_1;    // Send setup parameters_1
 SendWord();
 DTA = IF_N_1;
 SendWord();
 DTA = RF_R_1;
 SendWord();
 DTA = RF_N_1;
 SendWord();
 }  
 
 else {
 
 
 DTA= IF_R_2;    // Send setup parameters_2
 SendWord();
 DTA = IF_N_2;
 SendWord();
 DTA = RF_R_2;
 SendWord();
 DTA = RF_N_2;
 SendWord();
} 
delay (500); //jitter reduced due SPI refresh

//}   // uncomment togheter with "while true"

}



void loop() {  } // loop closed
   
   
  int SendWord() {
  bp = 22;
  do{
  bp = bp - 1;   //loop through bit positions 22 to 0
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA, bitRead(DTA,bp) ); 
  digitalWrite(CLK,HIGH); 
  }while(bp>0); 
  
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA,LOW);

  digitalWrite(LE,HIGH);   // Set LE to latch data
  delayMicroseconds(4); // 
  digitalWrite(LE,LOW);
}









